/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *  
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: ModelCarControl.h 113 2015-05-26 04:04:18Z honda $
 */

/*
 *		ǥ롼ץإåե
 */

#ifndef TOPPERS_MODEL_CAR_CONTROL_H
#define TOPPERS_MODEL_CAR_CONTROL_H

/*
 *  ̥إåե
 */
#include "driver_if.h"
#include "can_if.h"

/*
 *  ѥȥϢ : ˥塼ȥΥƥ󥰳٤ν
 */
#define STEER_NEUTRAL_INIT	0

/*
 * ®ƥ󥰺/Ǿ
 */
#define DRIVE_SPEED_MAX		64
#define DRIVE_SPEED_MIN		-63
#define STEER_ANGLE_MAX		64
#define STEER_ANGLE_MIN		-63

/*
 *  ƥ󥰥˥塼ȥĴͤκ/Ǿ
 */
#define STEER_NEUTRAL_MIN	-32
#define STEER_NEUTRAL_MAX	32

/*
 *  Ĵ
 */
#define SPEED_GAIN_INIT		6
#define SPEED_GAIN_MID		10
#define SPEED_GAIN_MIN		3
#define SPEED_GAIN_MAX		17

/*
 *  ܥǥϤεư
 */
#define BODY_CYCLE_MS		100U

/*
 *  DriveManagerεư
 */
#define DRIVEMANAGER_TASK_CYCLE_MS		20

/*
 *   : ưΥܥǥϤ³ƥ
 *           ǲǼ  
 */
#define INIT_BODY_BLINK_COUNT		3 
#define INIT_BODY_BLINK_CYCLE_MS	500

/*
 *   : CAN
 */
#define BODYCMD_CANMSG_SEND_CYCLE_MS	100

/*
 *  󥫡Ǽ
 */
#define WINKER_INTERVAL_MS	500U

/*
 *  ֥ѥ顼ॳХåμ
 */
#define BUZZER_CYCLE_NS		125U

/*
 *  ֥μ
 */
#define BUZZER_INTERVAL_MS	500U

/*
 *  ֥
 */
#define BUZZER_OFF			0U
#define BUZZER_ON			1U
#define BUZZER_INTERVAL_ON	2U

/*
 *  󥫡
 */
#define WINKER_OFF		0U
#define WINKER_L_ON		1U
#define WINKER_R_ON		2U
#define WINKER_LR_ON	3U
#define WINKER_L_BLINK	4U
#define WINKER_R_BLINK	5U
#define WINKER_LR_BLINK	6U

/*
 *  CAN˴ؤ 
 */

/*
 *  CANϢ : ܥǥϥޥCANåID
 */
#define BODYCMD_CANMSG_ID		16

/*
 *  CANϢ : ϥޥCANåID
 */
#define CONTCMD_CANMSG_ID		3

/*
 *  ƷϤưƱECUưƤTRUEȤʤ
 */
extern boolean IsBodyOnECU;
extern boolean IsOperatorOnECU;
extern boolean IsControlerOnECU;

/*
 *  ܥǥϤؤξֻؼ¤
 */
typedef struct {
	boolean headlamp;
	boolean foglamp;
	boolean brakelamp;
	boolean backlamp;
	uint8   winker;
	uint8   buzzer;
}BODYCMD;

/*
 *  ܥǥϤؤξֻؼѿ
 */
extern volatile BODYCMD g_bodycmd;

/*
 *  ܥǥϥޥɤCANåȤ
 */
extern void SendBodyCmdCanMag(void);

/*
 *  ܥǥϥޥɤCANåΥѥå
 */
extern void UnpackBodyCmdCanMsg(uint8 *p_rx_data);

/*
 *  Ϥؤλؼ¤
 */
typedef struct {
	sint8	angle;
	sint8	speed;
	sint8	steern;
	sint8	gain;
	boolean brake;
	boolean headlamp;
	boolean foglamp;
	boolean winker_l;
	boolean winker_r;
	boolean hazard;	
}CONTCMD;

/*
 *  ϤؤΥƥ󥰥˥塼ȥϢλؼ
 */
#define CONTCMD_STEERN_I	1U
#define CONTCMD_STEERN_R	2U
#define CONTCMD_STEERN_L	3U

/*
 *  ϤؤΥ⡼Ϣλؼ
 */
#define CONTCMD_GAIN_I	1U
#define CONTCMD_GAIN_U	2U
#define CONTCMD_GAIN_D	3U

/*
 *  ϤؤΥޥɹѿ(ƱECU)
 */
extern volatile boolean UpDateContCmd;

/*
 *  Ϥؤλؼѿ
 */
extern volatile CONTCMD g_contcmd;

/*
 *  ϥޥɤCANåȤ
 */
extern void SendContCmdCanMag(void);

/*
 *  ϥޥɤCANåΥѥå
 */
extern void UnpackContCmdCanMsg(uint8 *p_rx_data);

/*
 * ƥAPI
 */
extern void SetSteerAngle(sint8 angle);

/*
 *  ®API
 */
extern void SetDriveSpeed(sint8 speed);

/*
 *  ֥졼API
 */
extern void SetBrake(boolean brake);

/*
 *  BlinLedѤν(blinkled.c)
 */
extern void LedBlinkerInit(void);

/*
 *  ܥǥϤν(BodyControl.c)
 */
extern void BodyControlInit(void);


/*
 *  Ϥν(RcCar.c)
 */
extern void RcCarInit(void);


/*
 *  Ϥν(RcCar.c)
 */
extern void OperationInit(void);

#endif /* TOPPERS_MODEL_CAR_CONTROL_H */
